#ifndef FORECASTDISPLAY_H_
#define FORECASTDISPLAY_H_

#include <iostream>

#include "DisplayElement.h"
#include "Observer.h"
#include "Subject.h"
#include "WeatherData.h"

class ForecastDisplay : public Observer, DisplayElement
{
private:
    float currentPressure;
    float lastPressure;

    Subject *subject;

public:
    ForecastDisplay(Subject *sub)
        : currentPressure(29.92f), lastPressure(0), subject(sub)
    {
        subject->register_observer(this);
    }

    virtual ~ForecastDisplay() {}

    void update(float temp, float hum, float pres)
    {
        lastPressure = currentPressure;
        currentPressure = pres;

        display();
    }

    void display()
    {
        cout << "          Forecast: ";

        if (currentPressure > lastPressure)
        {
            cout << "Improving weather on the way!" << endl;
        }
        else if (currentPressure == lastPressure)
        {
            cout << "More of the same" << endl;
        }
        else if (currentPressure < lastPressure)
        {
            cout << "Watch out for cooler, rainy weather" << endl;
        }
    }
};

#endif /* FORECASTDISPLAY_H_ */
